unit UVerwaltung;

interface

uses
  SysUtils, WinTypes, WinProcs, Messages, Classes, Graphics, Controls,
  Forms, Dialogs, StdCtrls, ExtCtrls, Buttons,
  USortElement,UBasisobjekte,
  ULinListNode;


type TFVerwaltung = class(TForm)
    BtInsert: TButton;
    BtDelete: TButton;
    LbAusgabe: TListBox;
    EdAktuell: TEdit;

    procedure FormCreate(Sender: TObject);
    procedure BtInsertClick(Sender: TObject);
    procedure BtDeleteClick(Sender: TObject);
  private
     dummy : TLinListNode;
     procedure Anzeigen;
     procedure zeigeknoten(node:TLinListnode);
  end;

var FVerwaltung  : TFVerwaltung;

implementation


{$R *.DFM}

(*************************** private Methoden ****************************)

procedure TFVerwaltung.Anzeigen;
begin
    LbAusgabe.items.Clear;
    if dummy.readsucc <> nil then
        zeigeknoten(dummy.ReadSucc)
end;

procedure TFverwaltung.zeigeknoten(node:TLinListnode);
begin
   LBAusgabe.items.add(TString(node.readvalue).Getvalue);
   if node.readsucc <> nil then
      zeigeknoten(node.readsucc)
end;

(***********************  Ereignismethoden  ***********************************)

procedure TFVerwaltung.FormCreate(Sender: TObject);
begin
  dummy := TLinListnode.create(nil);
  dummy.writesucc(nil);
  Anzeigen;
end;

procedure TFVerwaltung.BtInsertClick(Sender: TObject);
var
  Str : TString;
  s:string;
  newnode :TlinListNode;
begin
   s       := EdAktuell.text;
   str     := TString.create(s);
   newnode := TlinListNode.Create(str);
   newnode.writesucc(dummy.readsucc);
   dummy.writesucc(newnode);
   anzeigen
end;


procedure TFVerwaltung.BtDeleteClick(Sender: TObject);
begin
(**aufg*)
end;

end.
