unit UListNode;
interface
uses sysutils,dialogs;
type
  TListNode = class(TObject)
              private
                Value:TObject;
                PredP{ointer}, SuccP{ointer}: TListNode;

{                               ListNode:
                     +--------+----------+--------+
         ListNode <--+- PredP |  Value   | SuccP -+--> ListNode
                     +--------+----------+--------+
 }
              public
                constructor Create(V:TObject);
                function ReadValue:TObject;
                procedure WriteValue(V:TObject);
                function ReadPred:TListnode;
                function ReadSucc:TListnode;
                procedure WritePred(Pred:TListnode);
                procedure WriteSucc(Succ:TListnode);
                destructor Destroy; override;
              end;

  Implementation

  constructor tlistnode.create(V:TObject);
  begin
    Value:=V;       (*    +---+----------+---+    *)
    Predp:=nil;     (*    | * |    V     | * |    *)
    Succp:=nil;     (*    +---+----------+---+    *)
  end;

  function tListnode.ReadValue:TObject;
  begin
   Result:=value
  end;

  procedure TListnode.WriteValue(V:TObject);
  begin
    Value:=V
  end;

  function TListnode.ReadPred:TListnode;
  begin
    Result:=PredP
  end;

  function TListnode.ReadSucc:TListnode;
  begin
    REsult:=SuccP
  end;

  procedure TListnode.WritePred(Pred:TListnode);
  begin
    PredP:=Pred
  end;

  procedure TListnode.WriteSucc(Succ:TListnode);
  begin
     SuccP:=Succ
  end;

  destructor TListNode.Destroy;
  begin
    value:=nil;
  end;

end.

