unit UDruck;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls,UDruckauftrag, ExtCtrls, Buttons, Menus,USchlange_TdvListNode;

type
  TFDruck = class(TForm)
    LBSchlange: TListBox;
    Label1: TLabel;
    Label2: TLabel;
    BtNeu: TButton;
    Label4: TLabel;
    EdNeu: TEdit;
    EdInArbeit: TEdit;
    LbZeit: TLabel;
    Timer1: TTimer;
    Label5: TLabel;
    Label3: TLabel;
    EdZeit: TEdit;
    procedure BtNeuClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure Timer1Timer(Sender: TObject);
    procedure zeige(schlange:TSchlange);
    procedure BtCloseClick(Sender: TObject);
    procedure Schlieen1Click(Sender: TObject);
  private
    zeit : Integer;
    druckerschlange:TSchlange;
    { Private-Deklarationen }
  public
    { Public-Deklarationen }
  end;

var
  FDruck: TFDruck;

implementation

{$R *.DFM}

(**************** hilfsprocs ***************)

procedure TFDruck.zeige (schlange:TSchlange); (* reine Hilfsprozedur*)
var hilfsschlange : TSchlange;
begin
   LBSchlange.items.clear;
   hilfsschlange := TSchlange.create;
   while not schlange.isempty do
      begin
         LBSchlange.items.add(TDruckauftrag(schlange.front).gettext);
         hilfsschlange.Enqueue(schlange.front);
         schlange.Dequeue
      end;
   while not hilfsschlange.isempty do
      begin
         schlange.Enqueue(hilfsschlange.front);
         hilfsschlange.Dequeue
      end;
   hilfsschlange.free
end; (* of zeige*)

procedure TFDruck.BtNeuClick(Sender: TObject);
var neu: TDruckauftrag;
begin
  neu := TDruckauftrag.create(zeit,EdNeu.Text);
  druckerschlange.Enqueue(neu);
  zeige (druckerschlange);
  EdInArbeit.text := TDruckauftrag(druckerschlange.front).GetText
end;

procedure TFDruck.FormCreate(Sender: TObject);
begin
   druckerschlange := TSchlange.create;
   druckerschlange.Enqueue(TDruckauftrag.create(0,'Bewerbung'));
   druckerschlange.Enqueue(TDruckauftrag.create(1,'Anzeige NOZ'));
   druckerschlange.Enqueue(TDruckauftrag.create(2,'Rechnung'));
   zeit := 1;
   zeige (druckerschlange);
   EdInArbeit.text := TDruckauftrag(druckerschlange.front).getText
end;

procedure TFDruck.Timer1Timer(Sender: TObject);
begin
   zeit := zeit +1;
   LbZeit.caption := IntToStr(zeit);
   if ((zeit mod StrToInt(EdZeit.text)) = 0)
      and (not druckerschlange.isempty) then
      begin
         druckerschlange.Dequeue;
         zeige (druckerschlange);
         if druckerschlange.isempty then
            EdInArbeit.text := ''
         else
            EdInArbeit.text := TDruckauftrag(druckerschlange.front).getText;
      end;

end;

procedure TFDruck.BtCloseClick(Sender: TObject);
begin
  close
end;

procedure TFDruck.Schlieen1Click(Sender: TObject);
begin
 close
end;

end.
