unit USchlange_TListNode;

interface

uses Classes, SysUtils,UListNode;


type
  TSchlange = class (TObject)
    private
      count:Integer;
      dummy:TListNode;
    public
      constructor Create;
      destructor  Destroy; override;

      procedure Enqueue (Element: TObject); virtual;
      procedure Dequeue; virtual;
      function  Front: TObject; virtual;
      function  IsEmpty: Boolean;virtual;
    end;

implementation

constructor TSchlange.Create;
begin
  dummy := TListNode.create(nil);
  dummy.WriteSucc(dummy);
  dummy.WritePred(dummy);
  count:=0
end;

destructor TSchlange.Destroy;
begin
   dummy.destroy;
   dummy := nil
end;

procedure TSchlange.Enqueue (Element: TObject);
var newNode:TListNode;
begin
   newNode:=TListNode.create(Element);
  (* vorne einketten *)
   NewNode.WritePred(dummy);
   NewNode.WriteSucc(dummy.ReadSucc);
   dummy.writeSucc(NewNode);
   NewNode.ReadSucc.WritePred(NewNode);
   inc(count)
end;

procedure TSchlange.Dequeue;
var lastNode:TListNode;
begin
   lastNode := dummy.ReadPred;
   lastNode.ReadPred.WriteSucc(dummy);
   dummy.writePred(LastNode.ReadPred);
   lastNode:=nil;
   dec(count)
end;

function TSchlange.Front: TObject;
begin
  Front := dummy.ReadPred.ReadValue
end;

function TSchlange.IsEmpty: Boolean;
begin
  IsEmpty := count=0
end;

end.

