UNIT FormWZ_Stufe_3b;

interface

uses 
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, mTPatientenSchlange, mTPatient;
// Uses-Klausel ggf. anpassen

type
   TForm3b = CLASS(TForm)

     // published Attribute
        btAbmelden : TButton;
        btAnmelden : TButton;
        edKasse : TEdit;
        edName : TEdit;
        Label1 : TLabel;
        LbAusgabeAnzahl : TLabel;
        lbAusgabeKasse : TLabel;
        lbAusgabePatient : TLabel;
        LbKasse : TLabel;
        lbKassen : TLabel;
        LbNaechsterPatient : TLabel;
        lbName : TLabel;
        LbPersonen : TLabel;
        lbWartezimmer : TLabel;

     // published Methoden
        procedure btAbmeldenClick(Sender:TObject);
        procedure btAnmeldenClick(Sender:TObject);
        procedure FormActivate(Sender:TObject);
        procedure FormClose(Sender:TObject; var Action:TCloseAction);
        procedure zeigeWartezimmer;

     // weitere Attribute
     private
        hatPatient : TPatient;
        hatSchlange : TPatientenSchlange;

     //Objektbeziehungen:
        // hatTPatientenschlange : TPatientenschlange;
        // hatTPatient (0..n) of TPatient;

   end;

var
  Form3b:  TForm3b;

implementation

{$R *.DFM}

//+---------------------------------------------------------------------
//|         TForm3b: Methodendefinition 
//+---------------------------------------------------------------------

//-------- btAbmeldenClick (published) ------------------------------------
procedure TForm3b.btAbmeldenClick(Sender:TObject);
begin
  hatSchlange.entferneKopf;
  self.zeigeWartezimmer;
end;

//-------- btAnmeldenClick (published) ------------------------------------
procedure TForm3b.btAnmeldenClick(Sender:TObject);
begin
  hatPatient := TPatient.init(edName.text,edKasse.text);
  hatSchlange.haengeAn(hatPatient);
  edName.Clear;
  edKasse.Clear;
  self.zeigeWartezimmer;
end;

//-------- FormActivate (published) ---------------------------------------
procedure TForm3b.FormActivate(Sender:TObject);
begin
  edName.clear;
  edKasse.clear;
  hatSchlange := TPatientenSchlange.init;
  zeigeWartezimmer;
end;

//-------- FormClose (published) ------------------------------------------
procedure TForm3b.FormClose(Sender:TObject; var Action:TCloseAction);
begin
  hatSchlange.gibFrei;
end;

//-------- zeigeWartezimmer (published) -----------------------------------
procedure TForm3b.zeigeWartezimmer;
begin
  IF hatSchlange.Kopf = nil
    THEN BEGIN
           lbAusgabePatient.caption := 'keiner';
           lbAusgabeKasse.caption := '';
         END
    ELSE BEGIN
           lbAusgabePatient.caption := hatSchlange.KopfAlsPatient.name;
           lbAusgabeKasse.caption := hatSchlange.KopfAlsPatient.kasse;
         END;
    lbAusgabeAnzahl.caption := IntToStr(hatSchlange.laenge)     
end;

end.
