UNIT FormWZ_Stufe_4;

interface

uses 
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, mTPatientenSchlange, mTPatient;
// Uses-Klausel ggf. anpassen

type
   TForm4 = CLASS(TForm)

     // published Attribute
        btAbmelden : TButton;
    btAnmeldenOhne: TButton;
        edKasse : TEdit;
        edName : TEdit;
    LbAnmeldung: TLabel;
        LbAusgabeAnzahl : TLabel;
        lbAusgabeKasse : TLabel;
        lbAusgabePatient : TLabel;
        LbKasse : TLabel;
        lbKassen : TLabel;
        LbNaechsterPatient : TLabel;
        lbName : TLabel;
        LbPersonen : TLabel;
        lbWartezimmer : TLabel;
    BtAnmeldenMit: TButton;
    LbVoruntersuchung: TLabel;
    LbAusgabePatientV: TLabel;
    LbAusgabeKasseV: TLabel;
    LbPersonenV: TLabel;
    LbNaechsterPatientV: TLabel;
    LbAusgabeAnzahlV: TLabel;
    LbKasseV: TLabel;
    BtZumWartezimmer: TButton;
    memoWartezimmer: TMemo;
    memoVoruntersuchung: TMemo;

     // published Methoden
        procedure btAbmeldenClick(Sender:TObject);
        procedure btAnmeldenOhneClick(Sender:TObject);
        procedure FormActivate(Sender:TObject);
        procedure FormClose(Sender:TObject; var Action:TCloseAction);
        procedure zeigeWartezimmer;
    procedure BtAnmeldenMitClick(Sender: TObject);
    procedure BtZumWartezimmerClick(Sender: TObject);

     // weitere Attribute
     private
        hatPatient : TPatient;
        hatWartezimmerschlange : TPatientenSchlange;
        hatVoruntersuchungsschlange : TPatientenSchlange;

     //Objektbeziehungen:
        // hatTPatientenschlange : TPatientenschlange;
        // hatTPatient (0..n) of TPatient;

   end;

var
  Form4:  TForm4;

implementation

{$R *.DFM}

//+---------------------------------------------------------------------
//|         TForm3b: Methodendefinition 
//+---------------------------------------------------------------------

//-------- btAbmeldenClick (published) ------------------------------------
procedure TForm4.btAbmeldenClick(Sender:TObject);
begin
  hatWartezimmerschlange.entferneKopf;
  self.zeigeWartezimmer;
end;

//-------- btAnmeldenClick (published) ------------------------------------
procedure TForm4.btAnmeldenOhneClick(Sender:TObject);
begin
  hatPatient := TPatient.init(edName.text,edKasse.text);
  hatWartezimmerschlange.haengeAn(hatPatient);
  edName.Clear;
  edKasse.Clear;
  self.zeigeWartezimmer;
end;

//-------- FormActivate (published) ---------------------------------------
procedure TForm4.FormActivate(Sender:TObject);
begin
  edName.clear;
  edKasse.clear;
  hatWartezimmerschlange := TPatientenSchlange.init;
  hatWartezimmerschlange.lerneMemoKennen(memoWartezimmer);
  hatVoruntersuchungsschlange := TPatientenSchlange.init;
  hatVoruntersuchungsschlange.lerneMemoKennen(memoVoruntersuchung);

  zeigeWartezimmer;
end;

//-------- FormClose (published) ------------------------------------------
procedure TForm4.FormClose(Sender:TObject; var Action:TCloseAction);
begin
  hatWartezimmerschlange.gibFrei;
  hatVoruntersuchungsschlange.gibFrei;
end;

//-------- zeigeWartezimmer (published) -----------------------------------
procedure TForm4.zeigeWartezimmer;
begin
  IF hatWartezimmerschlange.Kopf = nil
    THEN BEGIN
           lbAusgabePatient.caption := 'keiner';
           lbAusgabeKasse.caption := '';
         END
    ELSE BEGIN
           lbAusgabePatient.caption := hatWartezimmerschlange.KopfAlsPatient.name;
           lbAusgabeKasse.caption := hatWartezimmerschlange.KopfAlsPatient.kasse;
         END;
    lbAusgabeAnzahl.caption := IntToStr(hatWartezimmerschlange.laenge);
    hatWartezimmerSchlange.anzeigen;

  IF hatVoruntersuchungsschlange.Kopf = nil
    THEN BEGIN
           lbAusgabePatientV.caption := 'keiner';
           lbAusgabeKasseV.caption := '';
         END
    ELSE BEGIN
           lbAusgabePatientV.caption := hatVoruntersuchungsschlange.KopfAlsPatient.name;
           lbAusgabeKasseV.caption := hatVoruntersuchungsschlange.KopfAlsPatient.kasse;
         END;
    lbAusgabeAnzahlV.caption := IntToStr(hatVoruntersuchungsschlange.laenge);
    hatVoruntersuchungsSchlange.Anzeigen
end;

procedure TForm4.BtAnmeldenMitClick(Sender: TObject);
begin
  hatPatient := TPatient.init(edName.text,edKasse.text);
  hatWartezimmerschlange.haengeAn(hatPatient);
  hatVoruntersuchungsschlange.haengeAn(hatPatient);
  edName.Clear;
  edKasse.Clear;
  self.zeigeWartezimmer;
end;

procedure TForm4.BtZumWartezimmerClick(Sender: TObject);
begin
  hatVoruntersuchungsschlange.entferneKopf;
  self.zeigeWartezimmer;
end;

end.
