UNIT mTPatientenListe;

interface

uses   stdCtrls,mSuM,mTPAtient,mListe;
// Uses-Klausel ggf. anpassen

type
   TPatientenListe = CLASS(Liste)

     // weitere Attribute
     private
        kenntMemoAnzeige : TMemo;

     // weitere Methoden
     public
        procedure anzeigen;
        procedure lerneMemoKennen(pMemo:TMemo);
        function AktuellesAlsPatient : TPatient;

   end;

implementation

//+---------------------------------------------------------------------
//|         TPatientenListe: Methodendefinition 
//+---------------------------------------------------------------------

//-------- anzeigen (public) -------------------------------------------
procedure TPatientenListe.anzeigen;
begin
  kenntMemoAnzeige.Lines.Clear;
  if self.istLeer
    then
      begin
        kenntMemoAnzeige.Lines.Add('-- leer --')
      end
    else
      begin
        self.zumAnfang;
        while not self.istAmEnde do
           begin
             // die Klasse Patient ist anzupassen !!
             if self.AktuellesAlsPatient.Voruntersuchung then
                kenntMemoAnzeige.Lines.Add (self.AktuellesAlsPatient.Name + '  '
                                  + self.AktuellesAlsPatient.Kasse
                                  + ' -- z.Zt. VU')
             else
                kenntMemoAnzeige.Lines.Add (self.AktuellesAlsPatient.Name + '  '
                                  + self.AktuellesAlsPatient.Kasse );

              self.vor
           end;
             if self.AktuellesAlsPatient.Voruntersuchung then
                kenntMemoAnzeige.Lines.Add (self.AktuellesAlsPatient.Name + '  '
                                  + self.AktuellesAlsPatient.Kasse
                                  + ' -- z.Zt. VU')
             else
                kenntMemoAnzeige.Lines.Add (self.AktuellesAlsPatient.Name + '  '
                                  + self.AktuellesAlsPatient.Kasse );
         self.zumAnfang
      end;

end;

//-------- lerneMemoKennen (public) ------------------------------------
procedure TPatientenListe.lerneMemoKennen(pMemo:TMemo);
begin
  kenntMemoAnzeige := pMemo
end;

//-------- AktuellesAlsPatient (public) --------------------------------
function TPatientenListe.AktuellesAlsPatient : TPatient;
begin
  result := TPatient(self.aktuelles)
end;

end.
