UNIT mTPatientenschlange;

interface

uses  stdCtrls,mSuM,mTSchlange,mTPAtient;
// Uses-Klausel ggf. anpassen

type
   TPatientenschlange = CLASS(TSchlange)

     // weitere Attribute
     private
        kenntMemoAnzeige : TMemo;

     // weitere Methoden
     public
        procedure anzeigen;
        procedure lerneMemoKennen(pMemo:TMemo);
        function KopfAlsPatient : TPatient;

   end;

implementation

//+---------------------------------------------------------------------
//|         TPatientenschlange: Methodendefinition 
//+---------------------------------------------------------------------

//-------- anzeigen (public) -------------------------------------------
procedure TPatientenschlange.anzeigen;
var lSchlange : TPatientenSchlange ;
begin
  lSchlange := TPatientenschlange.init;
  kenntMemoAnzeige.Lines.Clear;
  if self.istLeer
    then
      begin
        kenntMemoAnzeige.Lines.Add('-- leer --')
      end
    else
      begin
        while not self.istLeer do
           begin
              kenntMemoAnzeige.Lines.Add (self.KopfAlsPatient.Name + '  '
                                  + self.KopfAlsPatient.Kasse);
              lSchlange.haengeAn(self.KopfAlsPatient);
              self.entferneKopf
           end;
        while not lSchlange.istLeer do
           begin
              self.haengeAn(lSchlange.KopfAlsPatient);
              lSchlange.entferneKopf
           end;
      end;
  lSchlange.gibfrei
end;

//-------- lerneMemoKennen (public) ------------------------------------
procedure TPatientenschlange.lerneMemoKennen(pMemo:TMemo);
begin
  kenntMemoAnzeige := pMemo
end;

//-------- KopfAlsPatient (public) -------------------------------------
function TPatientenschlange.KopfAlsPatient : TPatient;
begin
  result := TPatient(self.Kopf.inhalt)
end;

end.
