unit MHaupt;

interface

uses
  SysUtils, WinTypes, WinProcs, Messages, Classes, Graphics, Controls,
  Forms, Dialogs, StdCtrls, UlinList,MVokabel, ExtCtrls, Buttons, UVokabeleingabe
  ;


type TForm1 = class(TForm)
    Lbl1: TLabel;
    Eddeutsch: TEdit;
    ListBox1: TListBox;
    BtnachVorne: TButton;
    BtNachHinten: TButton;
    BtAnfangListe: TButton;
    BtEndeListe: TButton;
    Bevel1: TBevel;
    BtClose: TBitBtn;
    BtInsert: TBitBtn;
    BtDelete: TBitBtn;
    Edenglisch: TEdit;
    Label1: TLabel;
    Label2: TLabel;
    Bevel2: TBevel;

    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);

    procedure BtAnfangListeClick(Sender: TObject);
    procedure BtnachVorneClick(Sender: TObject);
    procedure BtNachHintenClick(Sender: TObject);
    procedure BtEndeListeClick(Sender: TObject);
    procedure BtCloseClick(Sender: TObject);
    procedure BtDeleteClick(Sender: TObject);
    procedure BtInsertClick(Sender: TObject);

    private
        hListe: TlinList;
        procedure Anfangswerte;
        procedure Anzeigen;
end;

var Form1: TForm1;
    inhalt : TVokabel;
    eingabe :TFVokabeleingabe;
    inh  : string;

implementation

{$R *.DFM}

(*************************** private Methoden ****************************)

procedure TForm1.Anfangswerte;
begin
  inhalt :=TVokabel.create;
  inhalt.setdeutsch('Vater');
  inhalt.setenglisch('father');
  hliste.add(inhalt);
  inhalt :=TVokabel.create;
  inhalt.setdeutsch('Mutter');
  inhalt.setenglisch('Mother');
  hliste.add(inhalt);
  inhalt :=TVokabel.create;
  inhalt.setdeutsch('Kind');
  inhalt.setenglisch('child');
  hliste.add(inhalt);
end;

procedure TForm1.Anzeigen;
var merk, aktuell: TVokabel;
begin
Listbox1.Items.Clear;
if not hliste.isempty then begin
    Merk := TVokabel(hListe.GetElement);
    Eddeutsch.text:=merk.Getdeutsch;
    Edenglisch.text := merk.Getenglisch ;
    hListe.first;
    while not hListe.islast do begin
      aktuell := TVokabel(hListe.GetElement);
      hListe.fw;
      ListBox1.Items.Add (aktuell.getdeutsch +' - ' +aktuell.getenglisch);
    end;
    aktuell := TVokabel(hListe.GetElement);
    ListBox1.Items.Add (aktuell.getdeutsch +' - ' +aktuell.getenglisch);
    hliste.first;
    aktuell := TVokabel (hliste.GetElement);

    while merk.Getdeutsch <> aktuell.Getdeutsch do begin
       hliste.fw ;
       aktuell := TVokabel(hListe.GetElement)
    end
  end (* of if*)
end; {procedure}

(***********************  Ereignismethoden  ***********************************)

procedure TForm1.FormCreate(Sender: TObject);
begin
  Form1.hListe := TlinList.CreateList;
  Anfangswerte;
  Anzeigen;
end;

procedure TForm1.FormDestroy(Sender: TObject);
begin
  hListe.last;
  while not hListe.isempty do begin
    hListe.GetElement.Destroy;
    hListe.Delete;
  end;
  hListe.free
end;

procedure TForm1.BtAnfangListeClick(Sender: TObject);
begin
  hListe.first;
  anzeigen;
end;

procedure TForm1.BtnachVorneClick(Sender: TObject);
begin
    hListe.bw;
    anzeigen;
end;

procedure TForm1.BtNachHintenClick(Sender: TObject);
begin
    hListe.fw;
    anzeigen;
end;

procedure TForm1.BtEndeListeClick(Sender: TObject);
begin
  hListe.last;
  anzeigen;
end;


procedure TForm1.BtCloseClick(Sender: TObject);
begin
  close
end;



procedure TForm1.BtDeleteClick(Sender: TObject);
begin
hliste.delete;
anzeigen;

end;

procedure TForm1.BtInsertClick(Sender: TObject);
begin
  Eingabe := TFVokabeleingabe.create(Form1) ;
  Eingabe.showmodal;
  if eingabe.eddeutsch.text <> '' then
   begin
    inhalt :=TVokabel.create;
    inhalt.setdeutsch(eingabe.eddeutsch.text);
    inhalt.setenglisch(eingabe.edenglisch.text);
    hliste.add(inhalt);
   end;
  eingabe.free;
  anzeigen 
end;

end.
