unit ULinlist;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs;

type
  TLinList = class(TList)
  private
      Index:Integer;
  public
  constructor createlist;   virtual;
  procedure first;          virtual;
  procedure last;           virtual;
  procedure fw;             virtual;
  procedure bw;             virtual;
  function isfirst:boolean; virtual;
  function islast:boolean;  virtual;
  function isempty:boolean; virtual;
  procedure insert(new: TObject); virtual;
  procedure add(new: TObject);    virtual;
  procedure delete;               virtual;
  function getelement:TObject;    virtual;


    { Public-Deklarationen }
  end;

implementation

  constructor TLinList.createlist;
  begin
  inherited create;
  Index := -1;
  end;

  procedure TLinList.first;
  begin
  if isempty  then
  messagedlg('!!!Die Liste ist leer!!!',mtError,[mbok],0)
  else
  index := 0;
  end;

  procedure TLinList.last;
  begin
  if isempty  then
  messagedlg('!!!Die Liste ist leer!!!',mtError,[mbok],0)
  else
  index := count-1;
  end;

  procedure TLinList.fw;
  begin
  if isempty  then
  messagedlg('!!!Die Liste ist leer!!!',mtError,[mbok],0)
  else
    if index < count-1 then
     index := index + 1
  end;

  procedure TLinList.bw;
  begin
  if isempty  then
  messagedlg('!!!Die Liste ist leer!!!',mtError,[mbok],0)
  else
    if index >0 then
    index := index - 1
  end;

  function TLinList.isfirst:boolean;
  begin
  if isempty  then begin
      messagedlg('!!!Die Liste ist leer!!!',mtError,[mbok],0);
      isfirst := false
     end
  else begin
      isfirst := (index = 0);
     end;
  end;

  function TLinList.islast:boolean;
  begin
  if isempty  then begin
     messagedlg('!!!Die Liste ist leer!!!',mtError,[mbok],0) ;
     islast:=false
    end
  else
     islast := (index = count-1);
  end;

function TLinList.isempty:boolean;
begin
  isempty := (index = -1);
end;

procedure TLinList.insert(new: TObject);
  begin
  if isempty then
       index := inherited add(new)
  else
       inherited insert(index,new)
  end;

  procedure TLinList.add(new: TObject);
  begin
     index := inherited add(new)
  end;

  procedure TLinList.delete;
  begin
  if isempty  then
     messagedlg('!!!Die Liste ist leer!!!',mtError,[mbok],0)
  else begin
     inherited delete(index);
     if index = count then
        index := index-1
    end
  end;

  function TLinList.getelement:TObject;
  begin
  if isempty  then begin
     messagedlg('!!!Die Liste ist leer!!!',mtError,[mbok],0);
     getelement := nil
    end
  else
     getelement := items[index]
  end;

end.
