unit Basisobjekte;
interface

type
    TInteger = class (TObject)
                Zahl: integer;
                constructor Create(Z:integer);
                function ReadValue:integer;
                function Compare(VObjekt:TInteger):integer;
                destructor destroy; override;
              end;
     TString =  class (TObject)
                 Text:string;
                 constructor Create(T:string);
                 function ReadValue:string;
                 function Compare(VObjekt:TString):integer;
                 destructor destroy; override;
               end;
     TReal =  class (TObject)
                 Number:real;
                 constructor Create(N:real);
                 function ReadValue:real;
                 function Compare(VObjekt:TReal):integer;
                 destructor destroy; override;
               end;
     TChar = class (TObject)
                 ch:char;
                 constructor Create(C:char);
                 function ReadValue:char;
                 function Compare(VObjekt:TChar):integer;
                 destructor destroy; override;
               end;

implementation


 constructor TInteger.Create(Z:integer);
 begin
   Zahl:=Z
 end;

 function TInteger.Readvalue:integer;
 begin
   Result:=Zahl
 end;

 function TInteger.Compare(VObjekt:TInteger):integer;
 begin
    if TInteger(VObjekt).Zahl<Zahl then
       Result:=1
    else if TInteger(VObjekt).Zahl= Zahl then
       Result:=0
    else Result:=-1
 end;

 destructor TInteger.Destroy;
 begin
 end;

 constructor TString.Create(T:string);
 begin
   text:=T
 end;

 function TString.ReadValue:string;
 begin
   Result:=Text
 end;

 function TString.Compare(VObjekt:TString):integer;
 begin
    if TString(VObjekt).Text<Text then
       Result:=1
    else if TString(VObjekt).Text= Text then
       Result:=0
    else Result:=-1
 end;

 destructor TString.destroy;
 begin
 end;

 constructor TReal.Create(N:real);
 begin
   Number:=N
 end;

 function TReal.ReadValue:real;
 begin
   Result:=Number
 end;

 function TReal.Compare(VObjekt:TReal):integer;
 begin
    if TReal(VObjekt).Number<Number then
       Result:=1
    else if TReal(VObjekt).Number = Number then
       Result:=0
    else Result:=-1
 end;

 destructor TReal.Destroy;
 begin
 end;

 constructor TChar.Create(C:char);
 begin
   ch:=C
 end;

 function TChar.ReadValue:char;
 begin
   Result:=CH
 end;


 function TChar.Compare(VObjekt:TChar):integer;
 begin
    if TChar(VObjekt).Ch<Ch then
       Result:=1
    else if TChar(VObjekt).Ch= Ch then
       Result:=0
    else Result:=-1
 end;


 destructor TChar.destroy;
 begin
 end;

end.
