unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  Grafik, StdCtrls, ListZeichenObj,Unit2, Unit3, Basisobjekte, Listenunit;

type
  TForm1 = class(TForm)
    create: TButton;
    insertBtn: TButton;
    extract: TButton;
    moveF: TButton;
    Zeichenflaeche1: TZeichenflaeche;
    schliessen: TButton;
    add: TButton;
    moveB: TButton;
    gotoFirst: TButton;
    gotoLast: TButton;
    getvalue: TButton;
    destroy: TButton;
    empty: TButton;
    procedure createClick(Sender: TObject);
    procedure schliessenClick(Sender: TObject);
    procedure insertBtnClick(Sender: TObject);
    procedure moveFClick(Sender: TObject);
    procedure moveBClick(Sender: TObject);
    procedure gotoFirstClick(Sender: TObject);
    procedure gotoLastClick(Sender: TObject);
    procedure gotoEndClick(Sender: TObject);
    procedure addClick(Sender: TObject);
    procedure extractClick(Sender: TObject);
    procedure deleteClick(Sender: TObject);
    procedure updateClick(Sender: TObject);
    procedure gotoIClick(Sender: TObject);
    procedure getvalueClick(Sender: TObject);
    procedure emptyClick(Sender: TObject);
    procedure atendClick(Sender: TObject);
    procedure FormPaint(Sender: TObject);
    procedure destroyClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
 private
    { Private-Deklarationen }
    GListe:TGList;
    procedure LoescheZeichenFlaeche;
  public
    { Public-Deklarationen }
  end;

var
  Form1: TForm1;

implementation

uses Unit4, Unit5;

{$R *.DFM}

procedure TForm1.LoescheZeichenFlaeche;
begin
  with ZeichenFlaeche1 do begin
    Stift.Farbe:=clWhite;
    Pinsel.FuellFarbe:=clWhite;
    BewegeBis(0,50);
    ZeichneREchteck(width,height);
    Stift.Farbe:=clBlack
  end
end;

procedure TForm1.createClick(Sender: TObject);
begin
   GListe:=TGList.create(zeichenflaeche1);
    create.enabled:=false;
   destroy.enabled:=true;
   insertBtn.enabled:=true;
   add.enabled:=true;
//   update.enabled:=true;
   getValue.enabled:=true;
   //delete.enabled:=true;
   extract.enabled:=true;
   moveF.enabled:=true;
   moveB.enabled:=true;
   gotoFirst.enabled:=true;
   gotoLast.enabled:=true;
   // gotoEnd.enabled:=true;
   // gotoI.enabled:=true;
   empty.enabled:=true;
   // atEnd.enabled:=true;
   schliessen.enabled:=true;
   GListe.Paint
end;


procedure TForm1.schliessenClick(Sender: TObject);
begin
  Close
end;

procedure TForm1.insertBtnClick(Sender: TObject);
var
  J:integer;
  S:string;
begin
  if GListe.N=5 then
    Messagedlg('Es knnen keine Knoten mehr eingefgt werden',mtWarning,[mbOK],0)
  else
    if Insert.ShowModal=mrOK then begin
       try
        S:=insert.edit1.text;
        case insert.Radiogroup1.itemindex of
        0: GListe.Insert(TInteger.create(strToInt(insert.Edit1.Text)),S);
        1: GListe.insert(TReal.create(strToFloat(insert.edit1.text)),S);
        2: GListe.insert(TString.create(insert.edit1.text),S);
        end;
        LoescheZeichenflaeche;
        Gliste.Paint
      except
          on EConvertError do
            case insert.Radiogroup1.Itemindex of
              0:showmessage('Keine ganze Zahl');
              1:showmessage('Keine Dezimalzahl');
            end;
        end;
    end;
end;

procedure TForm1.moveFClick(Sender: TObject);
begin
 Gliste.moveFwd;
 LoescheZeichenflaeche;
 GListe.Paint
end;

procedure TForm1.moveBClick(Sender: TObject);
begin
  Gliste.moveBwd;
 LoescheZeichenflaeche;
 GListe.Paint
end;

procedure TForm1.gotoFirstClick(Sender: TObject);
begin
 try
 gListe.gotoFirst;
 LoescheZeichenFlaeche;
 GListe.Paint;
 except
  on ListEmptyException do showmessage('Liste ist leer');
 end
end;

procedure TForm1.gotoLastClick(Sender: TObject);
begin
  try
   GListe.gotoLast;
   LoescheZeichenFlaeche;
   GListe.Paint
  except
    on ListEmptyException do showmessage('Liste ist leer');
  end
end;

procedure TForm1.gotoEndClick(Sender: TObject);
begin
  gListe.gotoEnd;
  LoescheZeichenFlaeche;
  GListe.Paint
end;

procedure TForm1.addClick(Sender: TObject);
begin
 gListe.gotoEnd;
 Insertbtnclick(Sender);
end;

procedure TForm1.extractClick(Sender: TObject);
begin
  try
  gListe.extract;
  LoescheZeichenFlaeche;
  GListe.Paint
  except
   on Listemptyexception do showMessage('Die Liste ist leer');
   on ListEndException do ShowMessage('Listenende erreicht');
  end;
end;

procedure TForm1.deleteClick(Sender: TObject);
begin
  try
  gListe.delete;
  LoescheZeichenFlaeche;
  GListe.Paint;
  except
   on ListEmptyException do showMessage('Liste ist leer');
  end
end;

procedure TForm1.updateClick(Sender: TObject);
var
  S:string;
  IZahl:integer;
  RZahl:real;
begin
  if GListe.I>0 then begin
  if Form3.ShowModal=mrOK then begin
        S:=Form3.edit1.text;
        try
        case Form3.Radiogroup1.itemindex of
        0: GListe.Update(TInteger.create(strToInt(Form3.Edit1.Text)),S);
        1: GListe.update(TReal.create(strToFloat(Form3.edit1.text)),S);
        2: GListe.update(TString.create(Form3.edit1.text),S);
        end;
        LoescheZeichenflaeche;
        Gliste.Paint
        except
          on EConvertError do
            case Form3.Radiogroup1.Itemindex of
              0:showmessage('Keine ganze Zahl');
              1:showmessage('Keine Dezimalzahl');
            end;
        end;
    end;
   end else showmessage('Listenende erreicht');
end;

procedure TForm1.gotoIClick(Sender: TObject);
var
  Pos:integer;
begin
 if not Gliste.Empty then begin
 if Form4.ShowModal=mrOK then begin
     Pos:=strtoInt(Form4.Edit1.Text);
     if (Pos>0) and (Pos<=5) then begin
       GListe.gotoI(Pos);
       LoescheZeichenflaeche;
       Gliste.Paint
     end
  end;
  end
 else
   ShowMessage('Liste ist leer');
end;

procedure TForm1.getvalueClick(Sender: TObject);
var
  P:TObject;
  IZahl:integer;
  RZahl:real;
  S:string;
  Fehler:boolean;
begin
   try
   P:=GListe.GetValue;
   Fehler:=false;
   with Form5 do begin
     edit1.Text:='';
     edit2.Text:='';
     edit3.text:='';
   end;
   if P is TInteger then begin
       IZahl:=TInteger(P).ReadValue;
       Form5.Edit1.Text:=IntToStr(IZahl);
   end else
     if P is TReal then begin
        RZahl:=TReal(P).Readvalue;
        Form5.Edit2.Text:=FloatToStr(RZahl)
     end else
         if P is TString  then begin
            S:=TString(P).Readvalue;
            Form5.Edit3.Text:=S
         end else
               Fehler:=true;
   if not Fehler then
     Form5.ShowModal
   except
     on ListEmptyexception do showMessage('Liste ist leer');
     on ListEndException do showMessage('Listenende erreicht');
   end;
end;

procedure TForm1.emptyClick(Sender: TObject);
begin
  if GListe.empty then
    Messagedlg('Die Liste ist leer. Die Funktion liefert "true"',mtInformation,[mbOK],0)
  else
    Messagedlg('Die Liste ist nicht leer. Die Funktion liefert "false"',mtInformation,[mbOK],0)
end;

procedure TForm1.atendClick(Sender: TObject);
begin
  if GListe.atEnd then
    Messagedlg('Der Listenzeiger steht am Ende der Liste. Die Funktion liefert "true"',mtInformation,[mbOK],0)
  else
    Messagedlg('Der Listenzeiger steht nicht am Ende der Liste. Die Funktion liefert "false"',mtInformation,[mbOK],0)
end;

procedure TForm1.FormPaint(Sender: TObject);
begin
    zeichenflaeche1.repaint;
    with Zeichenflaeche1 do begin
    Pinsel.Fuellfarbe:=clWhite;
    Stift.Hoch:=true;
    BewegeBis(30,20);
    Font.Size:=16;
    Font.Name:='Arial';
    Stift.Hoch:=false;
    Font.Style:=[fsBold];
    Schreibe('Doppelt verkettete lineare Liste');
    Stift.Hoch:=true;
    STift.Linienbreite:=2;
    Pinsel.FuellFarbe:=clfuchsia;
    BewegeBis(Width-150,20);
    ZeichneRechteck(50,30);
    BewegeBis(Width-150+15,27);
    Font.Size:=8;
    Schreibe('List');
    if GListe=nil then begin
      BewegeBis(width-150,49);
      ZeichneRechteck(50, 30);
      BewegeBis(width-130,57);
      Schreibe('nil');
    end;
   end;
end;


procedure TForm1.destroyClick(Sender: TObject);
begin
  GListe.destroy;
  GListe:=nil;
  LoescheZeichenflaeche;
   create.enabled:=true;
   destroy.enabled:=false;
   insertBtn.enabled:=false;
   add.enabled:=false;
   //update.enabled:=false;
   getValue.enabled:=false;
   //delete.enabled:=false;
   extract.enabled:=false;
   moveF.enabled:=false;
   moveB.enabled:=false;
   gotoFirst.enabled:=false;
   gotoLast.enabled:=false;
   // gotoEnd.enabled:=false;
   // gotoI.enabled:=false;
   empty.enabled:=false;
   // atEnd.enabled:=false;
   schliessen.enabled:=true;
  repaint;
end;

procedure TForm1.FormCreate(Sender: TObject);
begin
   GListe:=nil;
   create.enabled:=true;
   destroy.enabled:=false;
   insertBtn.enabled:=false;
   add.enabled:=false;
   //update.enabled:=false;
   getValue.enabled:=false;
   //delete.enabled:=false;
   extract.enabled:=false;
   moveF.enabled:=false;
   moveB.enabled:=false;
   gotoFirst.enabled:=false;
   gotoLast.enabled:=false;
   // gotoEnd.enabled:=false;
   // gotoI.enabled:=false;
   empty.enabled:=false;
   // atEnd.enabled:=false;
   schliessen.enabled:=true;
end;

procedure TForm1.FormClose(Sender: TObject; var Action: TCloseAction);
begin
 if Gliste<>nil then
   Gliste.destroy;
end;

end.
