unit UdvList;

interface

uses sysutils, classes, dialogs,stdctrls, UdvListNode, USortElement;

type TdvList = class(TObject)
     private
       Count,Index:integer;  {Hilfsvariable, sind zur Verwaltung nicht ntig }
       Dummy, ActualNode:TdvListNode;
     public
       constructor Create; virtual;
       destructor Destroy; override;
       procedure insert (Element: TObject); virtual;
       procedure add (Element: TObject); virtual;
       procedure Delete; virtual;
       procedure First; virtual;
       procedure Next; virtual;
       procedure Last; virtual;
       procedure Previous; virtual;
         function islast: boolean; virtual;
         function isfirst: boolean; virtual;
         function GetElement: TObject; virtual;
         function GetCount: integer; virtual; (*keine Listenmethode!!*)
         function GetIndex:integer;virtual;   (*keine Listenmethode!!*)
         function isempty: Boolean; virtual;
     end;

implementation

constructor TdvList.Create;
begin
    dummy:=TdvListNode.Create(nil);
    dummy.WritePred(dummy);
    dummy.WriteSucc(dummy);
    ActualNode:=Dummy;
    count := 0;
    Index:=0;
end;

destructor TdvList.Destroy;
 begin
   first;
   while not isempty do begin
     delete;
   end;
   Dummy.destroy;
   dummy:=nil;
 end;

procedure TdvList.Add (Element: TObject);
begin
   actualNode := dummy;
   insert(Element);     (* elegant !!*)
   index := count
end;

procedure TdvList.Insert (Element: TObject);
var
   newNode:TdvListNode;
 begin
   newNode:=TdvListNode.Create(Element);
   newNode.WriteSucc(actualNode);
   newNode.WritePred(actualNode.ReadPred);
   actualNode.writePred(newNode);
   newNode.ReadPred.WriteSucc(NewNode);
   actualNode := newNode;
   Inc(count);
   if count = 1 then  (* wenn das erste Element eingefgt wurde *)
      index := 1;
 end;

procedure TdvList.Delete;
var temp :TdvListNode;
 begin
   if isempty then showmessage('Delete bei leerer Liste')
   else begin
      actualNode.ReadPred.writeSucc(actualNode.ReadSucc);
      actualNode.ReadSucc.writePred(actualNode.ReadPred);
      temp := actualNode;
      if islast then begin
        actualnode := actualNode.ReadPred;
        index := count-1
      end (*of if*)
      else
         actualNode := actualNode.ReadSucc;
      temp.destroy; (* Es wird der Knoten gelscht, nicht
                       das Objekt, auf das der Knoten verweist *)
      Dec(count);
   end (*of else*)
end;

procedure TdvList.First;
begin
   if not isempty then begin
      actualNode := dummy.ReadSucc;
      Index := 1
   end
end;

procedure TdvList.Last;
begin
   if not isempty then begin
      actualNode := dummy.ReadPred;
      Index := count
   end
end;

procedure TdvList.Next;
 begin
   if not isempty and not islast then begin
      ActualNode := ActualNode.ReadSucc;
      Inc(Index);
   end
end;

procedure TdvList.Previous;
 begin
   if not isempty and not isfirst then begin
      ActualNode := ActualNode.ReadPred;
      Dec(Index);
   end
end;

function  TdvList.GetElement: TObject;
begin
    result := ActualNode.readValue
 end;

function TdvList.GetIndex: Integer;
   begin
       GetIndex := Index
   end ;

function TdvList.isempty: Boolean;
  begin
      isempty := actualNode.Readvalue = nil
  end;

function TdvList.islast: boolean;
begin
   islast:= isempty or (ActualNode.ReadSucc.Readvalue = nil)
end;

function TdvList.isfirst: boolean;
begin
   isfirst:= isempty or (ActualNode.ReadPred.ReadValue = nil)
end;

function TdvList.Getcount: integer;
  begin
     GetCount:= count
  end;

end.
