unit ULinListNode;
interface
uses sysutils,dialogs;
type
  TLinListNode = class(TObject)
              private
                ValueP{ointer}: TObject;
                SuccP{ointer} : TLinListNode;

{                               ListNode:
                     +----------+--------+
        Object <-----+- ValueP  | SuccP -+-----> ListNode
                     +----------+--------+
 }
              public
                constructor Create       (V:TObject);
                function    ReadValue      :TObject;
                procedure   WriteValue   (V:TObject);

                function    ReadSucc       :TLinListNode;
                procedure   WriteSucc (Succ:TLinListNode);
                destructor  Destroy; override;
              end;

  Implementation

  constructor TLinListNode.create(V:TObject);
  begin
    inherited create;
    ValueP:=V;      (*    +----------+---+    *)
    Succp:=nil;     (*    | ValueP   | * |    *)
  end;              (*    +----------+---+    *)

  function TLinListNode.ReadValue:TObject;
  begin
   (*** Aufg ***)
  end;

  procedure TLinListNode.WriteValue(V:TObject);
  begin
   (*** Aufg ***)
  end;

  function TLinListNode.ReadSucc:TLinListNode;
  begin
   (*** Aufg ***)
  end;

  procedure TLinListNode.WriteSucc(Succ:TLinListNode);
  begin
   (*** Aufg ***)
  end;

  destructor TLinListNode.Destroy;
  begin
    inherited destroy;
    (* nur der Knoten, d.h. die Verweise werden gelscht.
       Das Objekt auf das ValueP zeigt, wird nicht gelscht !!!
       Dafr ist das Objekt zustndig, das den Inhalt
       auch erzeugt hat !! *)
  end;

end.

