unit UStapel_HAT_DVListe;

interface

uses Classes, SysUtils, UdvListe;

type
  TStapel = class (TObject)
    private
      h_liste:TDVListe; (*HAT Liste*)
    public
      constructor Create;  
      destructor  Destroy; override;

      procedure Push (Element: TObject); virtual;
      procedure Pop; virtual;
      function  Top: TObject; virtual;
      function isempty:Boolean; virtual;
    end;

implementation

(****************************  TStapel  ***************************************)

constructor TStapel.Create;
begin
 h_liste:=TDVListe.Create
end;

destructor TStapel.Destroy;
begin
  h_liste.Destroy
end; 

procedure TStapel.Push (Element: TObject);
begin
  h_liste.First;
  h_liste.Insert (Element);
end;

procedure TStapel.Pop;
begin
  h_liste.Delete;
end;

function TStapel.Top: TObject;
begin
  Top := h_liste.GetElement
end;

function TStapel.isempty: Boolean;
begin
  result := h_liste.isempty
end;

end.

