unit UHanoi1;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls,UStapel_ListNode,UScheibe;

type
  TForm1 = class(TForm)
    LBA: TListBox;
    LBB: TListBox;
    LBC: TListBox;
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    EdHand: TEdit;
    Label4: TLabel;
    BrUmstapeln: TButton;
    EdAnzahl: TEdit;
    BtNeu: TButton;
    procedure BtNeuClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure BrUmstapelnClick(Sender: TObject);
    procedure zeige_alle_stapel;
    procedure turmtrans (n:Integer; VAR a,b,c :TStapel);
    procedure scheibentrans(var von,nach :TStapel);
   private
    stapel_a,stapel_b,stapel_c : TStapel;
  end;

var
  Form1: TForm1;

implementation

{$R *.DFM}

(**************** hilfsprocs ***************)

procedure leere (var st :TStapel);
begin
   while not st.isempty do begin
      st.top.free;
      st.pop
   end
end;

procedure zeige(st :TStapel; lb :TListbox);
var hilf :TStapel;
    zahl : Integer;
begin
   lb.clear;
   hilf := TStapel.create;
   while not st.isempty do begin
      zahl := TScheibe(st.top).get;
      lb.items.add(inttostr(zahl));
      hilf.push(st.top);
      st.pop
    end;
   while not hilf.isempty do begin
      st.push(hilf.top);
      hilf.pop
   end;
   hilf.free;
end;

procedure TForm1.zeige_alle_stapel;
begin
  zeige(stapel_a, LBA);
  zeige(stapel_b, LBB);
  zeige(stapel_c, LBC);
end;

procedure TForm1.turmtrans(n:Integer;var a,b,c :TStapel);
begin
   (* Aufgabe *)
end;

procedure TForm1.scheibentrans(var von,nach :TStapel);
var scheibe:Tscheibe;
begin
   (* Aufgabe *)
end;

procedure TForm1.BtNeuClick(Sender: TObject);
var i,anz : Integer;
    neu   :TScheibe;
begin
  anz := StrToInt(EdAnzahl.text);
  leere(stapel_a);
  leere(stapel_b);
  leere(stapel_c);
  for i := 1 to anz do begin
     neu := TScheibe.create;
     neu.put(anz-i+1);
     stapel_a.push(neu);
  end;
  zeige_alle_stapel
end;

procedure TForm1.FormCreate(Sender: TObject);
begin
   stapel_a := TStapel.create;
   stapel_b := TStapel.create;
   stapel_c := TStapel.create;
end;

procedure TForm1.BrUmstapelnClick(Sender: TObject);
begin
   if not stapel_a.isempty then
   turmtrans(StrToInt(EdAnzahl.text),stapel_a,stapel_b,stapel_c);
end;

end.
