unit UElemente;

interface

uses SysUtils, UListe;

TYPE
{ --------- Objekt TObjString -ein Nachkomme von TListObject-------- }
    TObjString = class (TListObject)
      Inhalt : string;
      function Get : string; override; // die leere Vatermethode berschreiben
    end;

{ --------- Objekt TObjInteger -ein Nachkomme von TListObject------- }
    TObjInteger = class (TListObject)
      Inhalt: integer;
      function Get : string; override;
    end;


implementation

{ --------- Objekt TObjString -------------------------------------- }

function TObjString.Get: string;
begin
  Result := Inhalt;
end;

{ --------- Objekt TObjInteger ------------------------------------- }

function TObjInteger.Get: string;
begin
  Result := IntToStr(Inhalt);
end;

end.
 