unit FormWZ_Stufe_3;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, mTSchlange, mTPatient;

type
  TForm3 = class(TForm)
    edName: TEdit;
    edKasse: TEdit;
    lbName: TLabel;
    lbKassen: TLabel;
    btAnmelden: TButton;
    btAbmelden: TButton;
    lbWartezimmer: TLabel;
    lbAusgabePatient: TLabel;
    lbAusgabeKasse: TLabel;
    Label1: TLabel;
    LbPersonen: TLabel;
    LbNaechsterPatient: TLabel;
    LbAusgabeAnzahl: TLabel;
    LbKasse: TLabel;
    procedure btAnmeldenClick(Sender: TObject);
    procedure btAbmeldenClick(Sender: TObject);
    procedure zeigeWartezimmer;
    procedure FormActivate(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    
  private
    { Private-Deklarationen }
    hatPatient  : TPatient;
    hatSchlange : TSchlange;
    //pPatient : TPatient;
  public
    { Public-Deklarationen }

  end;

var
  Form3: TForm3;

implementation

{$R *.DFM}

procedure TForm3.btAnmeldenClick(Sender: TObject);
begin
  hatPatient := TPatient.init(edName.text,edKasse.text);
  hatSchlange.haengeAn(hatPatient);
  edName.Clear;
  edKasse.Clear;
  self.zeigeWartezimmer;
end;

procedure TForm3.btAbmeldenClick(Sender: TObject);
begin
  hatSchlange.entferneKopf;
  self.zeigeWartezimmer;
end;

procedure TForm3.zeigeWartezimmer;
begin
  IF hatSchlange.Kopf = nil
    THEN BEGIN
           lbAusgabePatient.caption := 'keiner';
           lbAusgabeKasse.caption := '';
         END
    ELSE BEGIN
           lbAusgabePatient.caption := TPatient(hatSchlange.Kopf.Inhalt).name;
           lbAusgabeKasse.caption := TPatient(hatSchlange.Kopf.Inhalt).kasse;
         END;
    lbAusgabeAnzahl.caption := IntToStr(hatSchlange.laenge)     
end;

procedure TForm3.FormActivate(Sender: TObject);
begin
  edName.clear;
  edKasse.clear;
  hatSchlange := TSchlange.init;
  zeigeWartezimmer;
end;

procedure TForm3.FormClose(Sender: TObject; var Action: TCloseAction);
begin
  hatSchlange.gibFrei;
end;
end.
