UNIT FormWZ_Stufe_5;

interface

uses 
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, mTPatientenSchlange, mTPatient,
  mTPatientenListe;
// Uses-Klausel ggf. anpassen

type
   TForm5 = CLASS(TForm)

     // published Attribute
        btAbmelden : TButton;
        btAnmeldenOhne: TButton;
        edKasse : TEdit;
        edName : TEdit;
        LbAnmeldung: TLabel;
        LbAusgabeAnzahl : TLabel;
        lbAusgabeKasse : TLabel;
        lbAusgabePatient : TLabel;
        LbKasse : TLabel;
        lbKassen : TLabel;
        LbNaechsterPatient : TLabel;
        lbName : TLabel;
        LbPersonen : TLabel;
        lbWartezimmer : TLabel;
    BtAnmeldenMit: TButton;
    LbVoruntersuchung: TLabel;
    LbAusgabePatientV: TLabel;
    LbAusgabeKasseV: TLabel;
    LbPersonenV: TLabel;
    LbNaechsterPatientV: TLabel;
    LbAusgabeAnzahlV: TLabel;
    LbKasseV: TLabel;
    BtZumWartezimmer: TButton;
    memoWartezimmer: TMemo;
    memoVoruntersuchung: TMemo;

     // published Methoden
        procedure btAbmeldenClick(Sender:TObject);
        procedure btAnmeldenOhneClick(Sender:TObject);
        procedure FormActivate(Sender:TObject);
        procedure FormClose(Sender:TObject; var Action:TCloseAction);
        procedure zeigeWartezimmer;
    procedure BtAnmeldenMitClick(Sender: TObject);
    procedure BtZumWartezimmerClick(Sender: TObject);

     // weitere Attribute
     private
        hatPatient : TPatient;
        hatWartezimmerListe : TPatientenListe;
        hatVoruntersuchungsschlange : TPatientenSchlange;

     //Objektbeziehungen:
        // hatTPatientenschlange : TPatientenschlange;
        // hatTPatient (0..n) of TPatient;

   end;

var
  Form5:  TForm5;

implementation

{$R *.DFM}

//+---------------------------------------------------------------------
//|         TForm3b: Methodendefinition 
//+---------------------------------------------------------------------

//-------- btAbmeldenClick (published) ------------------------------------
procedure TForm5.btAbmeldenClick(Sender:TObject);
begin
  hatWartezimmerListe.zumAnfang;
  while not hatWartezimmerListe.istDahinter and
        hatWartezimmerliste.aktuellesAlsPatient.voruntersuchung do
           hatWartezimmerListe.vor;
  if not hatWartezimmerListe.istDahinter then
     begin
        hatWartezimmerListe.entferneAktuelles;
        self.zeigeWartezimmer;
     end   
end;

//-------- btAnmeldenClick (published) ------------------------------------
procedure TForm5.btAnmeldenOhneClick(Sender:TObject);
begin
  hatPatient := TPatient.init(edName.text,edKasse.text);
  hatWartezimmerListe.haengeAn(hatPatient);
  edName.Clear;
  edKasse.Clear;
  self.zeigeWartezimmer;
end;

//-------- FormActivate (published) ---------------------------------------
procedure TForm5.FormActivate(Sender:TObject);
begin
  edName.clear;
  edKasse.clear;
  hatWartezimmerListe := TpatientenListe.init;
  hatWartezimmerListe.lerneMemoKennen(memoWartezimmer);
  hatVoruntersuchungsschlange := TPatientenSchlange.init;
  hatVoruntersuchungsschlange.lerneMemoKennen(memoVoruntersuchung);

  zeigeWartezimmer;
end;

//-------- FormClose (published) ------------------------------------------
procedure TForm5.FormClose(Sender:TObject; var Action:TCloseAction);
begin
  hatWartezimmerListe.gibFrei;
  hatVoruntersuchungsschlange.gibFrei;
end;

//-------- zeigeWartezimmer (published) -----------------------------------
procedure TForm5.zeigeWartezimmer;
begin
  IF hatWartezimmerListe.istLeer 
    THEN BEGIN
           lbAusgabePatient.caption := 'keiner';
           lbAusgabeKasse.caption := '';
         END
    ELSE BEGIN
           hatWartezimmerListe.zumAnfang;
           while (not hatWartezimmerListe.istdahinter) and
                 hatWartezimmerListe.AktuellesAlsPatient.Voruntersuchung do
                 hatWartezimmerListe.vor;
           if hatWartezimmerListe.istDahinter
           then
              begin
                 lbAusgabePatient.caption := ' - niemand ist bereit - ';
                 lbAusgabeKasse.caption := ''
              end
           else
              begin
                 lbAusgabePatient.caption := TPatient(hatWartezimmerListe.aktuelles).name;
                 lbAusgabeKasse.caption := TPatient(hatWartezimmerListe.aktuelles).kasse;
              end   
         END;
    lbAusgabeAnzahl.caption := IntToStr(hatWartezimmerListe.laenge);
    hatWartezimmerListe.anzeigen;
  IF hatVoruntersuchungsschlange.Kopf = nil
    THEN BEGIN
           lbAusgabePatientV.caption := 'keiner';
           lbAusgabeKasseV.caption := '';
         END
    ELSE BEGIN
           lbAusgabePatientV.caption := hatVoruntersuchungsschlange.KopfAlsPatient.name;
           lbAusgabeKasseV.caption := hatVoruntersuchungsschlange.KopfAlsPatient.kasse;
         END;
    lbAusgabeAnzahlV.caption := IntToStr(hatVoruntersuchungsschlange.laenge);
    hatVoruntersuchungsSchlange.Anzeigen
end;

procedure TForm5.BtAnmeldenMitClick(Sender: TObject);
begin
  hatPatient := TPatient.init(edName.text,edKasse.text);
  hatPatient.zurVoruntersuchung;
  hatWartezimmerListe.haengeAn(hatPatient);
  hatVoruntersuchungsschlange.haengeAn(hatPatient);
  edName.Clear;
  edKasse.Clear;
  self.zeigeWartezimmer;
end;

procedure TForm5.BtZumWartezimmerClick(Sender: TObject);
begin
  hatVoruntersuchungsschlange.KopfAlsPatient.VoruntersuchungBeendet;
  hatVoruntersuchungsschlange.entferneKopf;
  self.zeigeWartezimmer;
end;

end.
