UNIT mTSchlange;

interface

uses  
      Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
      StdCtrls, mSuM, mTKnoten, mTPatient;
// Uses-Klausel ggf. anpassen

type
   TSchlange = CLASS

     // weitere Attribute
     private
        zAnzahl : Integer;
        hatKopf : TKnoten;

     //Objektbeziehungen:
        // hatTKnoten (0..n) of TKnoten;

     // weitere Methoden
     public
        constructor init;
        procedure entferneKopf;
        procedure haengeAn(pInhalt:TObject);
        function istLeer : Wahrheitswert;
        function Kopf : TKnoten;
        function laenge : GanzeZahl;
        destructor gibfrei;

   end;

implementation

//+---------------------------------------------------------------------
//|         TSchlange: Methodendefinition 
//+---------------------------------------------------------------------

//-------- init (public) -----------------------------------------------
constructor TSchlange.init;
begin
  hatKopf := nil;
  zAnzahl := 0
end;

//-------- entferneKopf (public) ---------------------------------------
procedure TSchlange.entferneKopf;
Var lLoeschKopf : TKnoten;
begin
  IF hatKopf <> nil
    THEN BEGIN
           lLoeschKopf := hatKopf;
           hatKopf := hatKopf.nachfolger;
           lLoeschKopf.GibFrei;
           zAnzahl := zAnzahl-1
         END;
end;

//-------- haengeAn (public) -------------------------------------------
procedure TSchlange.haengeAn(pInhalt:TObject);
Var lLetzterKnoten,lNeuerKnoten : TKnoten;
begin
  IF hatKopf = nil
    THEN BEGIN
           hatKopf := TKnoten.Init(pInhalt,nil);
         END
    ELSE BEGIN
           lLetzterKnoten := hatKopf;
           WHILE lLetzterKnoten.nachfolger <> nil DO
             BEGIN
               lLetzterKnoten := lLetzterKnoten.nachfolger;
             END;  
           lNeuerKnoten := TKnoten.init(pInhalt,nil);
           lLetzterKnoten.setzeNachfolger(lNeuerKnoten);
         END;
     zAnzahl := zAnzahl+1
end;

//-------- istLeer (public) --------------------------------------------
function TSchlange.istLeer : Wahrheitswert;
begin
   result := hatKopf=nil
end;

//-------- Kopf (public) -----------------------------------------------
function TSchlange.Kopf : TKnoten;
begin
   if hatKopf = nil
      then result := nil
      else result := hatKopf
end;

//-------- laenge (public) ---------------------------------------------
function TSchlange.laenge : GanzeZahl;
begin
  laenge := zAnzahl
end;

//-------- gibfrei (public) --------------------------------------------
destructor TSchlange.gibfrei;
begin
  While hatKopf <> nil do
    //self.entfernePatient;
end;

end.
